;; http://www.census.gov/censusexplorer/censusexplorer.html

(defun MoransI(rates adj &key mean print)
  "
;; Examples:
 ;; these rates are median salaries for Newport census tracts, from census
 ;; explorer.
 (def rates '(
	     19779 ;; 501
	     51071 ;; 504
	     28507 ;; 505
	     24538 ;; 506
	     37917 ;; 524
	     55711 ;; 525
	     37772 ;; 532
 ))
 (def adj (matrix (list 7 7) '(
				 0 0 0 1 0 0 1 ;; 501
				 0 0 1 0 1 0 1 ;; 504
				 0 1 0 1 1 1 1 ;; 505
				 1 0 1 0 0 1 0 ;; 506
				 0 1 1 0 0 1 0 ;; 524
				 0 0 1 1 1 0 0 ;; 525
				 1 1 1 0 0 0 0 ;; 532
			       )))
 (MoransI rates adj :print t)
"
  (let* (
	 (mean (if mean mean (mean rates)))
	 (z (- rates mean))
	 (N (length z))
	 (So (sum adj))
	 (bigsum (dot z (matmult  adj z)))
	 (MoransI (/
	      (* N bigsum) 
	      (* So (dot z z))
	      )
	     )
	 )
    (if print
	(let ()
	  (print 'adjacency)
	  (mprint adj)
	  (print 'data-locations)
	  (mprint 
	   (bind-columns
	    '(rates mean-rate z sum-sq-z N So bigsum MoransI)
	    (list rates mean z (sum (square z)) N So bigsum MoransI)
	    )
	   )
	  )
      )
    MoransI
    )
  )
(try-out MoransI)

(def simulation
     (mapcar 
      (lambda(n)
	(MoransI (sample rates (length rates)) adj :print nil)
	)
      (iseq 10000)
      )
     )
(print (length (remove-dups simulation)))
(matrix-column-stats (bind-columns simulation)
		     :names (list "MoransI")
		     )
(def simulation (sort-data simulation))


#|
Stuff for Andy!
|#


(def svd (svd adj))
(def q (first svd))

(mprint (matmult (first svd) (diagonal (second svd)) (transpose (third svd)))  t :float-digits 2)
(symmetric-matrix-p adj)

(mprint q)
(def singvals (second svd))
(print singvals)

(def rates (column 1 q))
(MoransI rates adj)

(def rates (column 7 q))
(MoransI rates adj)

(mapcar 
 (lambda(x) 
   (def rates (column x q)) 
   (moransI rates adj :mean 0)
   ) 
 (iseq 1 7)
 )

(def rates (column 1 q)) 


